////////////////////////////
//
//	Clip-4-Win DLL / CallDLL() definitions
//
//	Copyright (C) 1994 Skelton Software, Kendal Cottage, Hillam, Leeds, UK.
//	All Rights Reserved.
//
////////////////////////////

#ifdef	RC_INVOKED
  #ifndef	C4W_DLL_CH
  #define	C4W_DLL_CH
  #endif
#endif

#ifdef	WORKSHOP_INVOKED
  #ifndef	C4W_DLL_CH
  #define	C4W_DLL_CH
  #endif
#endif


#ifndef	C4W_DLL_CH
#define	C4W_DLL_CH

#xtranslate _IF_(.T., [<t>], [<f>])	=> <t>
#xtranslate _IF_(.F., [<t>], [<f>])	=> <f>

#xtranslate _NOREF_	=>
#xtranslate _NOREF_ @	=>

#command _DLL [<static:STATIC>]						;
         FUNCTION <name>( [<p1> AS <type1>]				;
                          [, <pN> AS <typeN>] )				;
         AS <returnType>						;
         [<callType:PASCAL>]						;
									;
      => _DLL [<static>]						;
         FUNCTION <name>( [<p1> AS <type1>]				;
                          [, <pN> AS <typeN>] )				;
         AS <returnType>						;
         PASCAL:.<name>

#command _DLL [<static:STATIC>]						;
         FUNCTION <name>( [<p1> AS <type1>,]				;
                          <pR> REF <typeR>				;
                          [, <pN> <asr: AS, REF> <typeN>] )		;
         AS <returnType>						;
         [<callType:PASCAL,C>]:[<lib>].<entryName>			;
									;
      => _DLL <static>							;
         FUNCTION <name>( [<p1> AS <type1>,]				;
                          @<pR> AS <typeR>				;
                          [, <pN> <asr> <typeN>] )			;
         AS <returnType>						;
         <callType>:<lib>.<entryName>

/*
#command _DLL [<static:STATIC>]						;
         FUNCTION <name>( [<p1> AS <type1>]				;
                          [, <pN> AS <typeN>] )				;
         AS <returnType>						;
         [<callType:PASCAL,C>]:.<entryName>				;
									;
      => [<static>] FUNCTION <name>( _NOREF_ <p1> [, _NOREF_ <pN>] )	;
       ; LOCAL _c := GetProcAddress( , <(entryName)>, <(callType)>,	;
                                     <(returnType)>,			;
                                     <(type1)> [+"," + <(typeN)>] )	;
       ; LOCAL _uRet := CallDLL( _c [, <p1>] [, <pN>] )			;
       ; RETURN _uRet
*/

#command _DLL [<static:STATIC>]						;
         FUNCTION <name>( [<p1> AS <type1>]				;
                          [, <pN> AS <typeN>] )				;
         AS <returnType>						;
         [<callType:PASCAL,C>]:[<lib>].<entryName>			;
									;
      => <static> FUNCTION <name>( _NOREF_ <p1> [, _NOREF_ <pN>] )	;
      [; LOCAL _hLib := LoadLibrary( <(lib)> ) ]			;
       ; LOCAL _c := GetProcAddress( _IF_(<.lib.>, _hLib, ),		;
                                     <(entryName)>, <(callType)>,	;
                                     <(returnType)>,			;
                                     <(type1)> [+"," + <(typeN)>] )	;
       ; LOCAL _uRet := CallDLL( _c [, <p1>] [, <pN>] )			;
       ; IF <.lib.>							;
       ;    FreeLibrary( _IF_(<.lib.>, _hLib, ) )			;
       ; END								;
       ; RETURN _uRet

#command _NDLL [<static:STATIC>]					;
         FUNCTION <name>( [<p1> AS <type1>]				;
                          [, <pN> AS <typeN>] )				;
         AS <returnType>						;
         [<callType:PASCAL,C>]:<lib>. <entryNum>			;
									;
      => [<static>] FUNCTION <name>( _NOREF_ <p1> [, _NOREF_ <pN>] )	;
       ; LOCAL _hLib := LoadLibrary( <(lib)> )				;
       ; LOCAL _c := GetProcAddress( _hLib, <entryNum>, <(callType)>,	;
                                     <(returnType)>,			;
                                     <(type1)> [+"," + <(typeN)>] )	;
       ; LOCAL _uRet := CallDLL( _c [, <p1>] [, <pN>] )			;
       ; FreeLibrary( _hLib )						;
       ; RETURN _uRet

#command _NDLL [<static:STATIC>]					;
         FUNCTION <name>( [<p1> AS <type1>,]				;
                          <pR> REF <typeR>				;
                          [, <pN> <asr: AS, REF> <typeN>] )		;
         AS <returnType>						;
         [<callType:PASCAL,C>]:[<lib>]. <entryNum>			;
									;
      => _NDLL <static>							;
         FUNCTION <name>( [<p1> AS <type1>,]				;
                          @<pR> AS <typeR>				;
                          [, <pN> <asr> <typeN>] )			;
         AS <returnType>						;
         <callType>:<lib>. <entryNum>


#endif	// C4W_DLL_CH
