////////////////////////////
//
//	Clip-4-Win ODBC definitions
//
//	Copyright (C) 1994 Skelton Software, Kendal Cottage, Hillam, Leeds, UK.
//	All Rights Reserved.
//
////////////////////////////

#ifdef	RC_INVOKED
  #ifndef	C4W_ODBC_CH
  #define	C4W_ODBC_CH
  #endif
#endif

#ifdef	WORKSHOP_INVOKED
  #ifndef	C4W_ODBC_CH
  #define	C4W_ODBC_CH
  #endif
#endif


#ifndef	C4W_ODBC_CH
#define	C4W_ODBC_CH

// Status codes:

#define	SQL_INVALID_HANDLE	-2
#define	SQL_ERROR		-1
#define	SQL_SUCCESS		0
#define	SQL_SUCCESS_WITH_INFO	1
#define	SQL_NO_DATA		100

// Data types:

#define	SQL_CHAR	1
#define	SQL_NUMERIC	2
#define	SQL_DECIMAL	3
#define	SQL_INTEGER	4
#define	SQL_SMALLINT	5
#define	SQL_FLOAT	6
#define	SQL_REAL	7
#define	SQL_DOUBLE	8
#define	SQL_DATE	9
#define	SQL_VARCHAR	12	// memo (or just char)
#define	SQL_LONGVARCHAR	-1	// memo (or just char)
#define	SQL_TINYINT	-6
#define	SQL_BIT		-7	// logical

// SQLFreeStmt():

#define	SQL_CLOSE	0
#define	SQL_DROP	1
#define	SQL_UNBIND	2
#define	SQL_RESET_PARAMS 3

// SQLSetConnectOption():

#define	SQL_AUTOCOMMIT		102

#define	SQL_ODBC_CURSORS	110	// ODBC 2.0

	#define	SQL_CUR_USE_IF_NEEDED	0


// SQLSetPos():

#define	SQL_POSITION	0
#define	SQL_REFRESH	1
#define	SQL_UPDATE	2
#define	SQL_DELETE	3
#define	SQL_ADD		4

// Locking:

#define	SQL_LOCK_NO_CHANGE	0
#define	SQL_LOCK_EXCLUSIVE	1
#define	SQL_LOCK_UNLOCK		2

// Fetching data sources:

#define	SQL_FETCH_DIRECTION	8

#define	SQL_FETCH_NEXT	1
#define	SQL_FETCH_FIRST	2
#define	SQL_FETCH_LAST	3
#define	SQL_FETCH_PRIOR	4
#define	SQL_FETCH_ABSOLUTE 5
#define	SQL_FETCH_RELATIVE 6

// SQLGet/SetStmtOption():

#define	SQL_CURSOR_TYPE	6

#define	SQL_CURSOR_DYNAMIC	2
#define	SQL_CURSOR_STATIC	3

// SQLTransact():

#define	SQL_COMMIT	0
#define	SQL_ROLLBACK	1

#endif	// C4W_ODBC_CH

