////////////////////////////
//
//	Clip-4-Win CREATESTRUCT definitions
//
//	Copyright (C) 1993 Skelton Software, Kendal Cottage, Hillam, Leeds, UK.
//	All Rights Reserved.
//
//	For use mainly with MDI windows.
//
//	(Also those keen developers who want to do special processing of
//	WM_CREATE.)
//
////////////////////////////

#ifndef	C4W_CS_CH
#define	C4W_CS_CH


// Array elements of aCs[], which is passed with WM_CREATE when creating
// a new window (actually, a2bin(aCs, CS_STRUCT_DEF) is passed)
//
// (these correspond to the members of the Windows CREATESTRUCT structure)

#define	CS_lpCreateParams 1	// extra data to use during creation
#define	CS_hInstance	2	// app instance to be the owner
#define	CS_hMenu	3	// menu to be used
#define	CS_hwndParent	4	// parent window (0 for a top-level window)
#define	CS_cy		5	// height
#define	CS_cx		6	// width
#define	CS_y		7	// y co-ord
#define	CS_x		8	// x co-ord
#define	CS_style	9	// window style (WS_* values)
#define	CS_lpszName	10	// title for the new window
#define	CS_lpszClass	11	// window class
#define	CS_dwExStyle	12	// extended window style (WS_EX_* values)

#define	CS_LENGTH	12	// length of array

#define	CS_STRUCT_DEF	"str,int[7],long,str[2],dword" // for a2bin(), bin2a()


#endif	// C4W_CS_CH

