echo off
if %1. == @. echo on
if %1. == @. shift
if %1. == . goto missing

goto c4wlib

echo Building Application Class Library (C4WCLASS.LIB)
echo ...
cd source\oo\classes
rmake c4wclass.rmk
copy c4wclass.lib ..\..\..\lib
cd ..\..\..

:c4wlib
echo ...
echo Building CLIP4WIN.LIB
echo ...
if %1 == 5.3 goto p53
if %1 == 5.3a goto p53a
if %1 == 5.3A goto p53a
if %1 == 5.2d goto p52d
if %1 == 5.2D goto p52d
if %1 == 52d goto p52d
if %1 == 52D goto p52d
if %1 == 5.2e goto p52e
if %1 == 5.2E goto p52e
if %1 == 52e goto p52e
if %1 == 52E goto p52e
if %1 == 5.01 goto p501
if %1 == 501 goto p501
if %1 == 5.01a goto p501a
if %1 == 5.01A goto p501a
if %1 == 501a goto p501a
if %1 == 501A goto p501a
if %1 == 5.01ae goto p501ae
if %1 == 5.01AE goto p501ae
if %1 == 501ae goto p501ae
if %1 == 501AE goto p501ae
goto badver

:p501
echo Sorry!  5.01 is not supported.
goto exit

cd 501\lib
..\..\install\getmod %2 clipper.lib 5.01
c4w501
if errorlevel 1 goto err
copy ..\..\52\lib\p2_in.tmp
p2_501
if errorlevel 1 goto err
copy /b c4wp1.tmp+c4wp2.tmp clip4win.lib
copy clip4win.lib ..\..\lib
del c4wp?.tmp
..\..\install\getmod %2 cld.lib 5.01
dbg501
if errorlevel 1 goto err
ren c4wp1.tmp c4wdbg.lib
copy c4wdbg.lib ..\..\lib
cd ..\..
goto exit

:p501a
echo Sorry!  5.01a is not supported.
goto exit
cls
echo                        Error!
echo You should make sure you have 5.01ae (clipper.lib 16/10/92 6:00)
echo Then use %0 5.01ae %2
goto exit

:p501ae
echo Sorry!  5.01ae is not supported.
goto exit

cd 501\lib
..\..\install\getmod %2 clipper.lib 5.01ae
c4w501ae
if errorlevel 1 goto err
copy ..\..\52\lib\p2_in.tmp
p2_501ae
if errorlevel 1 goto err
copy /b c4wp1.tmp+c4wp2.tmp clip4win.lib
copy clip4win.lib ..\..\lib
del c4wp?.tmp
..\..\install\getmod %2 cld.lib 5.01ae
dbg501ae
if errorlevel 1 goto err
ren c4wp1.tmp c4wdbg.lib
copy c4wdbg.lib ..\..\lib
cd ..\..
goto exit

:p52e
cd 52\lib
..\..\install\getmod %2 clipper.lib 5.2e
c4w52e
if errorlevel 1 goto err
copy /b c4wp1.tmp+p2_in.tmp clip4win.lib
copy clip4win.lib ..\..\lib
del c4wp?.tmp
..\..\install\getmod %2 cld.lib 5.2e
dbg52e
if errorlevel 1 goto err
ren c4wp1.tmp c4wdbg.lib
copy c4wdbg.lib ..\..\lib
cd ..\..
goto exit

:p52d
cd 52\lib
..\..\install\getmod %2 clipper.lib 5.2d
copy c4wtmp.tmp 52d.tmp
del c4wtmp.tmp
c4w52d
if errorlevel 1 goto err
c4w52e
if errorlevel 1 goto err
copy /b c4wp1.tmp+p2_in.tmp clip4win.lib
copy clip4win.lib ..\..\lib
del c4wp?.tmp
..\..\install\getmod %2 cld.lib 5.2d
dbg52e
if errorlevel 1 goto err
ren c4wp1.tmp c4wdbg.lib
copy c4wdbg.lib ..\..\lib
cd ..\..
goto exit

:p52d_old
cd 52\lib
..\..\install\getmod %2 clipper.lib 5.2d
c4w52d
if errorlevel 1 goto err
copy p2_in.tmp p2_in.tm2
p2_52d
if errorlevel 1 goto err
copy /b c4wp1.tmp+c4wp2.tmp clip4win.lib
copy clip4win.lib ..\..\lib
del c4wp?.tmp
ren p2_in.tm2 p2_in.tmp
..\..\install\getmod %2 cld.lib 5.2d
dbg52d
if errorlevel 1 goto err
ren c4wp1.tmp c4wdbg.lib
copy c4wdbg.lib ..\..\lib
cd ..\..
goto exit

:p53
cd 53\lib
..\..\install\getmod %2 clipper.lib 5.3
c4w53
if errorlevel 1 goto err
copy ..\..\52\lib\p2_in.tmp
p2_53
if errorlevel 1 goto err
copy /b c4wp1.tmp+c4wp2.tmp clip4win.lib
copy clip4win.lib ..\..\lib
del c4wp?.tmp
..\..\install\getmod %2 cld.lib 5.3
dbg53
if errorlevel 1 goto err
copy c4wp1.tmp ..\..\lib\c4wdbg.lib
cd ..\..
goto exit

:p53a
cd 53\lib
..\..\install\getmod %2 clipper.lib 5.3
copy c4wtmp.tmp 53a.tmp
del c4wtmp.tmp
c4w53a
if errorlevel 1 goto err
c4w53
if errorlevel 1 goto err
copy ..\..\52\lib\p2_in.tmp
p2_53
if errorlevel 1 goto err
copy /b c4wp1.tmp+c4wp2.tmp clip4win.lib
copy clip4win.lib ..\..\lib
del c4wp?.tmp
..\..\install\getmod %2 cld.lib 5.3
dbg53
if errorlevel 1 goto err
ren c4wp1.tmp c4wdbg.lib
copy c4wdbg.lib ..\..\lib
cd ..\..
goto exit

:missing
cls
echo                        Error!
echo You need to specify which version of the Lib you want.
echo Syntax:
echo          MAKELIBS  ver  [d:dir]
echo The d:dir is a drive/directory, and can be omitted if your LIB
echo environment variable can be used to find CLIPPER.LIB and CLD.LIB.
goto vers

:badver
cls
echo                        Error!
echo You need to specify a supported version of Clipper.
goto vers

:vers
echo Supported versions are: 5.3a, 5.3, 5.2e, 5.2d.
goto exit

:enverr
echo You need more environment space.
goto exit

:err
cd ..\..
echo Error!
goto exit

:exit

