
#include "windows.ch"
#include "dialog.ch"
#define	NO_C4WCLASS
#include "commands.ch"

static	mName
static	mFTName
static	mAddr_1
static	mAddr_2
static	mAddr_3
static	mAddr_4
static	mAddr_5
static	mContact
static	mTelephone
static	mFax


function main()
local	oApp, oWnd

CREATE APPLICATION oApp  WINDOW oWnd  TITLE "Clip-4-Win Data Entry"	;
	ON INIT MyForm(oWnd)

return nil


static function MyForm(oWnd)
local	GetList

local	aDlg, nRet

mName      := SPACE(35)
mFTName    := SPACE(35)
mAddr_1    := SPACE(35)
mAddr_2    := SPACE(20)
mAddr_3    := SPACE(20)
mAddr_4    := SPACE(15)
mAddr_5    := SPACE(10)
mContact   := SPACE(25)
mTelephone := SPACE(15)
mFax       := SPACE(15)

DO WHILE .T.
   CLEAR GETS
   CREATE DIALOG aDlg  TITLE "Add Contact"  AT 50,10 SIZE 220,160
   @ ID 100 SAY    "Name: "         AT 10,12  SIZE 45,10
   @ ID 210 EDIT                    AT 48,10  SIZE 105,14
   @ ID 101 SAY    "Address 1: "    AT 10,28  SIZE 45,10
   @ ID 211 EDIT                    AT 48,26  SIZE 105,14
   @ ID 102 SAY    "Address 2: "    AT 10,44  SIZE 45,10
   @ ID 212 EDIT                    AT 48,42  SIZE 60,14
   @ ID 103 SAY    "Address 3: "    AT 10,60  SIZE 45,10
   @ ID 213 EDIT                    AT 48,58  SIZE 60,14
   @ ID 104 SAY    "Address 4: "    AT 10,76  SIZE 45,10
   @ ID 214 EDIT                    AT 48,74  SIZE 45,14
   @ ID 105 SAY    "Post Code: "    AT 120,76  SIZE 35,10
   @ ID 215 EDIT                    AT 158,74  SIZE 35,14
   @ ID 106 SAY    "Contact: "      AT 10,92  SIZE 45,10
   @ ID 216 EDIT                    AT 48,90  SIZE 75,14
   @ ID 107 SAY    "Telephone: "    AT 10,108  SIZE 45,10
   @ ID 217 EDIT                    AT 48,106  SIZE 45,14
   @ ID 108 SAY    "Fax No: "       AT 120,108 SIZE 35,10
   @ ID 218 EDIT                    AT 158,106  SIZE 45,14
   @ ID 109 SAY    "FT Name: "      AT 10,124  SIZE 45,10
   @ ID 219 EDIT                    AT 48,122  SIZE 105,14
   @ ID 300 SUNKENFRAME             AT  3,145  SIZE 214,13
   @ ID 301 SAY    ""               AT  5,147  SIZE 190,10

   // dialogs behave as if this button always exists:
   // (let's use it to do extra validation)
   @ ID IDOK BUTTON OnOk(GetList)

   SHOW DIALOG aDlg  RESULT nRet  ON INIT {|hDlg| FormInit(hDlg, GetList)}

   if nRet == IDCANCEL
      EXIT
   ENDIF

   // update ...
ENDDO

PostQuitMessage(0)
RETURN NIL


static function FormInit(hDlg, GetList)
@ DIALOG hDlg ID 210 GET mName      PICTURE '@!' valid genval(!empty(mName),"Need a Name Please", hDlg)
@ DIALOG hDlg ID 211 GET mAddr_1    PICTURE '@!' valid genval(!empty(mAddr_1),"Need an Address Please", hDlg)
@ DIALOG hDlg ID 212 GET mAddr_2    PICTURE '@!' valid genval(!empty(mAddr_2),"Need an Address Please", hDlg)
@ DIALOG hDlg ID 213 GET mAddr_3    PICTURE '@!' valid genval(!empty(mAddr_3),"Need an Address Please", hDlg)
@ DIALOG hDlg ID 214 GET mAddr_4    PICTURE '@!'
@ DIALOG hDlg ID 215 GET mAddr_5    PICTURE '@!'
@ DIALOG hDlg ID 216 GET mContact   PICTURE '@!' valid genval(!empty(mContact),"Need a Contact Please", hDlg)
@ DIALOG hDlg ID 217 GET mTelephone PICTURE '@!' valid genval(!empty(mTelephone),"Need a Telephone Number Please", hDlg)
@ DIALOG hDlg ID 218 GET mFax       PICTURE '@!'
@ DIALOG hDlg ID 219 GET mFTName    PICTURE '@!' valid genval(!empty(mFTName),"Need a Name for Financial Transactions Please", hDlg)
return nil


static function OnOk(GetList, hDlg)
local	aRequired := {.t., .t., .t., .t., .f., .f., .t., .t., .f., .t.}
local	i, n := len(GetList), oGet

// check all required fields have been entered
for i = 1 to n
	oGet = GetList[i]
	if !oGet:BadDate() .and. oGet:Changed
		oGet:Assign()
	endif
	if aRequired[i]
		if empty(oGet:VarGet())
			// force input focus to this one!
			// Note: the ID's count from 210...
			SetFocus(GetDlgItem(hDlg, 210 + i - 1))
			exit
		endif
	endif
next i

return nil


static function genval(lOk, cMsg, hDlg)
SetDlgItemText(hDlg, 301, "")
if !lOk
	SetDlgItemText(hDlg, 301, cMsg)
	tone(523.3,0.5)
endif
return lOk

