//	Circ3Dem.prg - CIRC3.VBX Demo (OO version)
//
//	Written by:	John M. Skelton,  Nov-94.
//
//	Copyright (C) 1994 Skelton Software, Kendal Cottage, Hillam, Leeds LS25 5HP, UK.
//	All Rights Reserved.
//
//	Part of Clip-4-Win.

#define	WIN_WANT_ALL
#include "windows.ch"
#include "topclass.ch"
#include "commands.ch"
#include "circ3dem.ch"


function main()
local	oApp, oWnd

CREATE APPLICATION oApp  WINDOW oWnd  TITLE "Clip-4-Win VBX Demo"	;
	ON INIT DemoDlg(oWnd)

VBXTerm()

return 0


CLASS MyCIRC3 INHERIT WVBXCIRC3
	METHOD ClickIn(nX, nY, cCaption)				;
	       INLINE super:ClickIn(@nX, @nY, @cCaption),		;
	              ; //::oParent:MsgBox(cCaption),			;
	              ::oParent:ClickIn()
ENDCLASS


static function DemoDlg(oWnd)
local	oDlg

oDlg = MyVBXDialog{oWnd, "VBXDemoDlg"}

PostQuitMessage(0)
return nil


CLASS MyVBXDialog INHERIT WVBXDialog
	PROTECT nCirc	AS INT
	PROTECT oCirc	AS OBJECT
	PROTECT oSay	AS OBJECT

	METHOD ChangeOrientation()					;
	       INLINE local	n,					;
	              n := ::oCirc:GetPropByName("CircleShape"),	;
;//	              n := ::oCirc:GetProp(12),				;
	              ::oCirc:SetPropByName("CircleShape",		;
;//	              ::oCirc:SetProp(12,				;
	                                    iif(n == 0, 1, 0))

	METHOD ClickIn()						;
	       INLINE ::oCirc:Caption := ltrim(str(++::nCirc)),		;
;//	              ::oCirc:SetPropByName("Caption", ltrim(str(::nCirc))),;
;//	              ::oCirc:SetProp(14, ltrim(str(::nCirc))),		;
	              ::oSay:Text := str(::nCirc)  // show value in dialog

	METHOD OnInitDialog(hCtrlFocus, nPtr)

	ACCESS Value			INLINE ::nCirc
	ASSIGN Value(nNew)						;
	       INLINE ::nCirc := nNew,					;
	              ::oSay:Text := str(nNew), ; // show value in dialog
	              nNew
ENDCLASS


METHOD OnInitDialog(hCtrlFocus, nPtr) CLASS MyVBXDialog
::nCirc = 0

@ ID IDC_CIRCLE1  CIRCLE  Object ::oCirc

@ ID IDC_CHANGE_ORIENTATION BUTTON ChangeOrientation

@ ID IDC_VALUE  SAY str(::nCirc)  Object ::oSay

return super:OnInitDialog(hCtrlFocus, nPtr)

