#include "windows.ch"
#include "topclass.ch"
#include "commands.ch"

function main()
local	oApp, oWnd

USE users NEW SHARED

CREATE APPLICATION oApp  CLASS MyApp					;
    WINDOW oWnd								;
    TITLE "Clip-4-Win Makes Windows Apps E-A-S-Y!"			;
    ON INIT oWnd:MenuSetup()

return nil


CLASS MyApp INHERIT WApp
    METHOD Create(cText)    INLINE ::oWnd := MyWindow{self, cText, , .f.}
ENDCLASS


CLASS MyWindow INHERIT WSDIWindow
    METHOD Create(cText)						;
        INLINE super:Create(cText),					;
               ::StatusBar := WStatusBar{self},				;
               self
    METHOD MenuSetup()
ENDCLASS


METHOD MenuSetup() CLASS MyWindow

MENU IN self
    POPUP "&File"
        MENUITEM "&Browse"  ACTION WBrowseDef(self) HELP WHelp{"Browse USERS file"}
        MENUITEM SEPARATOR
        MENUITEM "E&xit"    ACTION ::App:Quit()    HELP WHelp{"Exit this application"}
    ENDPOPUP
    POPUP "&Help"
        MENUITEM "&About"  ACTION MessageBox( , "Easy!", "Clip-4-Win App") ;
            HELP WHelp{"About this application"}
    ENDPOPUP
ENDMENU

return nil
