/////////////////////////
//
//	combo.prg - OO Demo of Combo Boxes
//
//	Written by:	John M. Skelton, Sep-95.
//
//	Copyright (C) 1993-1995 Skelton Software, Kendal Cottage, Hillam, Leeds LS25 5HP, UK.
//	All Rights Reserved.
//
/////////////////////////

#define	WIN_WANT_CB
#include "windows.ch"
#include "topclass.ch"
#include "commands.ch"

#define	CTLSTYLE	WS_TABSTOP + WS_VISIBLE + WS_CHILD


function main()
local	oApp, oWnd

CREATE APPLICATION oApp							;
    WINDOW oWnd								;
    TITLE "Clip-4-Win Makes Windows Apps E-A-S-Y!"			;
    ON INIT Demo(oWnd)

return nil


static function Demo(oWnd)
local	oDlg, oText, oOld, oCB1, oCB2, oCB3
local	a1 := {"Make Selections!", "BBBB", "CCCC", "DDDD"}
local	a2 := {"Item 1", "Number 2", "The 3rd", "4th item"}
local	a3 := {"item 1", "number 2", "3rd item", "#4"}

CREATE DIALOG oDlg  TITLE "ComboBox Demo"  AT 40,40 SIZE 150,150	;
    STYLE DS_MODALFRAME+WS_POPUP+WS_CAPTION  IN oWnd

@ ID 999 CENTERTEXT "Gets Replaced"  OBJ oText  AT 40,5   SIZE 70,10  IN oDlg
@ ID 998 SAY        "Gets Replaced"  OBJ oOld   AT 40,20  SIZE 70,10  IN oDlg

@ ID 11 ComboBox  OBJ oCB1  ITEMS  a1  AT 20,30  SIZE 70,40		;
     STYLE CBS_SIMPLE + WS_VSCROLL + CTLSTYLE				;
     ACTION oText:Text := oCB1:CurItem  IN oDlg

@ ID 12 ComboBox  OBJ oCB2  ITEMS  a2  AT 20,70  SIZE 70,50		;
     STYLE CBS_DROPDOWNLIST + WS_VSCROLL + CTLSTYLE			;
     ACTION oText:Text := oCB2:CurItem  IN oDlg

@ ID 13 ComboBox  OBJ oCB3  ITEMS  a3  AT 20,100  SIZE 70,50		;
     STYLE CBS_DROPDOWN + WS_VSCROLL + CTLSTYLE				;
     ACTION (oOld:Text := oText:Text, oText:Text := oCB3:CurItem)  IN oDlg

SHOW DIALOG oDlg

PostQuitMessage()
return nil

