////////////////////////////
//
//	Clip-4-Win video MCI sample (OO)
//
//	Copyright (C) 1994 Skelton Software, Kendal Cottage, Hillam, Leeds, UK.
//	All Rights Reserved.
//
////////////////////////////

#include "windows.ch"
#include "dll.ch"
#include "commands.ch"


function main()
local	oApp, oWnd

CREATE APPLICATION oApp  WINDOW oWnd					;
	TITLE "Clip-4-Win Media Control Interface"			;
	ON INIT (DoVideo{oWnd}, PostQuitMessage())

return 0


CLASS DoVideo INHERIT WDialog
	PROTECT lOpen	AS LOGIC
	PROTECT nStatus	AS INT

	METHOD Init(oParent)
	METHOD Open()
	METHOD Play()
ENDCLASS


METHOD Init(oParent) CLASS DoVideo
::lOpen = .f.
super:Init(oParent, , .f., .t.)

INIT DIALOG self  TITLE "Clip-4-Win AVI Sample"  AT 10,10 SIZE 200,150

@ ID IDCANCEL  BUTTON        TEXT "&Cancel"      AT 150,10  SIZE 40,12
@ ID 101       BUTTON  Open  TEXT "&Open Video"  AT 150,30  SIZE 40,12
@ ID 102       BUTTON  Play  TEXT "&Play Video"  AT 150,50  SIZE 40,12

::Create()

if ::lOpen
	mciExecute("close TheVid")
endif

return self


METHOD Open() CLASS DoVideo
local	cFile, cCmd

if ::lOpen
	mciExecute("close TheVid")
endif

if (cFile := GetOpenFileName(::hWnd, "*.AVI", "Select a video to play",	;
                             {{"Video Files (*.AVI)", "*.AVI"}})) == nil
	return nil
endif

cCmd = "open " + cFile + " type avivideo alias TheVid style child"		;
       + " parent " + ltrim(str(::hWnd))

::nStatus = mciExecute(cCmd)

::nStatus = mciExecute("put TheVid window at 10 10 280 280")

::lOpen = .t.
return 1


METHOD Play() CLASS DoVideo
if ::lOpen
	mciExecute("seek TheVid to start")
endif
mciExecute("play TheVid")
return 1


_DLL function mciExecute(cCmd AS STRING) AS INT Pascal:MMSystem.mciExecute

