//	VBXDemo.prg - VBX Demo (OO version)
//
//	Written by:	John M. Skelton,  Nov-94.
//
//	Copyright (C) 1994 Skelton Software, Kendal Cottage, Hillam, Leeds LS25 5HP, UK.
//	All Rights Reserved.
//
//	Part of Clip-4-Win.
//
//	Thanks to Matt Pietrek.

#define	WIN_WANT_ALL
#include "windows.ch"
#include "topclass.ch"
//#define	NO_C4WCLASS
#include "commands.ch"
#include "vbxdemo.h"


function main()
local	oApp, oWnd

CREATE APPLICATION oApp  WINDOW oWnd  TITLE "Clip-4-Win VBX Demo"	;
	ON INIT DemoDlg(oWnd)

VBXTerm()

return 0


static function DemoDlg(oWnd)
local	oDlg

oDlg = MyVBXDialog{oWnd, "VBXDemoDlg"}

PostQuitMessage(0)
return nil


CLASS MyVBXDialog INHERIT WVBXDialog
	PROTECT nSpin	AS INT
	PROTECT oSpin	AS OBJECT
	PROTECT oSay	AS OBJECT

	METHOD ChangeOrientation()					;
	       INLINE local	n,					;
	              n := ::oSpin:GetPropByName("SpinOrientation"),	;
;//	              n := ::oSpin:GetProp(24),				;
	              ::oSpin:SetPropByName("SpinOrientation",		;
;//	              ::oSpin:SetProp(24,				;
	                                    iif(n == 0, 1, 0))

	METHOD OnInitDialog(hCtrlFocus, nPtr)

	ACCESS Value			INLINE ::nSpin
	ASSIGN Value(nNew)						;
	       INLINE ::nSpin := nNew,					;
	              ::oSay:Text := str(nNew), ; // show value in dialog
	              nNew
ENDCLASS


METHOD OnInitDialog(hCtrlFocus, nPtr) CLASS MyVBXDialog
::nSpin = 0

@ ID IDC_SPIN1 VBX  Object ::oSpin					;
	ON SpinUp   ::Value++		; // ::MsgBox("SpinUp", "VBX")	;
	ON SpinDown ::Value--		  // ::MsgBox("SpinDown", "VBX")

@ ID IDC_CHANGE_ORIENTATION BUTTON ChangeOrientation

@ ID IDC_VALUE  SAY str(::nSpin)  Object ::oSay

return super:OnInitDialog(hCtrlFocus, nPtr)

