//	VBXDemo2.prg - VBX Demo (non-OO)
//
//	Written by:	John M. Skelton,  Mar-95.
//
//	Copyright (C) 1995 Skelton Software, Kendal Cottage, Hillam, Leeds LS25 5HP, UK.
//	All Rights Reserved.
//
//	Part of Clip-4-Win.
//
//	Thanks to Matt Pietrek.

#define	WIN_WANT_ALL
#include "windows.ch"
//#include "topclass.ch"
#define	NO_C4WCLASS
#include "commands.ch"
#include "vbxdemo.h"
#include "vbxbi.ch"


function main()
local	oApp, oWnd

CREATE APPLICATION oApp  WINDOW oWnd  TITLE "Clip-4-Win VBX Demo"	;
	ON INIT DemoDlg(oWnd)

VBXTerm()

return 0


static function DemoDlg(oWnd)
static	nSpin := 0
local	oDlg

CREATE DIALOG oDlg RESOURCE "VBXDemoDlg" VBX

@ ID IDC_SPIN1 VBX IN oDlg						;
;//	ON SpinUp {|hDlg| MessageBox(hDlg, "SpinUp", "VBX")}		;
	ON SpinUp {|hDlg| SetDlgItemText(hDlg, IDC_VALUE, str(++nSpin))} ;
;//	ON SpinDown {|hDlg| MessageBox(hDlg, "SpinDown", "VBX")}
	ON SpinDown {|hDlg| SetDlgItemText(hDlg, IDC_VALUE, str(--nSpin))}

@ ID IDC_CHANGE_ORIENTATION BUTTON ChangeOrientation IN oDlg

@ ID IDC_VALUE SAY str(nSpin) IN oDlg

SHOW DIALOG oDlg IN oWnd

PostQuitMessage(0)
return nil


static function ChangeOrientation(hDlg)
local	hCtl := VBXGetHctl(GetDlgItem(hDlg, IDC_SPIN1))
local	nValue := VBXGetPropByName(hCtl, "SpinOrientation")
//MessageBox(hDlg, str(nValue), "nValue")
VBXSetPropByName(hCtl, "SpinOrientation", iif(nValue == 0, 1, 0))
return 1

