/////////////////////////
//
//	createdc.prg - Windows API: CreateDC() with awkward params
//
//	Written by:	John M. Skelton, 24-Mar-94.
//
//	Copyright (C) 1994 Skelton Software, Kendal Cottage, Hillam, Leeds LS25 5HP, UK.
//	All Rights Reserved.
//
/////////////////////////


#include "windows.ch"

#xtranslate	ADD PARAM <p> TO <c>				;
		=>	if <p> == nil				;
		;		<p> := 0			;
		;	end					;
		;	<c> += iif(valtype(<p>) == "C", ",str", ",long")


// This is complicated by allowing the cnXXX params to be char, numeric or nil

function CreateDC(cDriver, cnDevice, cnOutput, cnParams)
local hLib := LoadLibrary("GDI.EXE")
local c := "str"

ADD PARAM cnDevice TO c
ADD PARAM cnOutput TO c
ADD PARAM cnParams TO c
c := GetProcAddress(hLib, "CreateDC", "Pascal", "int", c)
return CallDLL(c, cDriver, cnDevice, cnOutput, cnParams)
