/////////////////////////
//
//	gpvprofs.prg - Windows API: GetPrivateProfileString() with awkward params
//
//	Written by:	John M. Skelton, 12-Apr-94.
//
//	Copyright (C) 1994 Skelton Software, Kendal Cottage, Hillam, Leeds LS25 5HP, UK.
//	All Rights Reserved.
//
/////////////////////////


#include "windows.ch"

#xtranslate	ADD PARAM <p> TO <c>				;
		=>	if <p> == nil				;
		;		<p> := 0			;
		;	end					;
		;	<c> += iif(valtype(<p>) == "C", ",str", ",long")


// This is complicated by allowing the cnXXX param to be char, numeric or nil

function GPvProfString(cSection, cnEntry, cDefault, cFile)
local hLib := LoadLibrary("kernel.exe")
local c := "str"
local n, cBuf := space(2048)		// or whatever
ADD PARAM cnEntry TO c
c += ",str,str,int,str"
c := GetProcAddress(hLib, "GetPrivateProfileString", "Pascal", ;
		    "int", c)
n := CallDLL(c, cSection, cnEntry, cDefault, @cBuf, len(cBuf), cFile)
return left(cBuf, n)

