////////////////////////////
//
//	Clip-4-Win MCI sample
//
//	Copyright (C) 1994 Skelton Software, Kendal Cottage, Hillam, Leeds, UK.
//	All Rights Reserved.
//
////////////////////////////


#include "windows.ch"

function main()
local	hWnd := WinSetup("mci", "Clip-4-Win Media Control Interface")

mci("sysinfo all quantity")
wait

mci("sysinfo waveaudio quantity")
wait

mci("sysinfo waveaudio name 1")
wait

mci("capability waveaudio can play")
wait

mci("info waveaudio product")
wait

return 0


function mci(cCmd)
local	cResult, nRet, lRet

cResult := space(256)
nRet := mciSendString(cCmd, @cResult)
cResult := left(cResult, at(chr(0), cResult) - 1)

? cResult

cResult := space(256)
lRet := mciGetErrorString(nRet, @cResult)
cResult := left(cResult, at(chr(0), cResult) - 1)

? cResult

return lRet


function mciSendString(cCmd, cResult)	// --> nErr
local	hLib := LoadLibrary("mmsystem.dll")
local	cDLL := GetProcAddress(hLib, "mciSendString", "Pascal", "long",	;
				"string,string,int,int")
return CallDLL(cDLL, cCmd, @cResult, len(cResult), 0)	// 0 for no callback


function mciGetErrorString(nErr, cResult)  // --> lSuccess
local	hLib := LoadLibrary("mmsystem.dll")
local	cDLL := GetProcAddress(hLib, "mciGetErrorString", "Pascal", "bool", ;
				"long,string,int")
return CallDLL(cDLL, nErr, @cResult, len(cResult))

