/////////////////////////
//
//	valrect.prg - Windows API: ValidateRect() with awkward params
//
//	Written by:	John M. Skelton, 25-Mar-94.
//
//	Copyright (C) 1994 Skelton Software, Kendal Cottage, Hillam, Leeds LS25 5HP, UK.
//	All Rights Reserved.
//
/////////////////////////


STATIC PROCEDURE ValidateRect(hWnd, aRect)
LOCAL hLib := LoadLibrary("user.exe")
LOCAL c1 := GetProcAddress(hLib, "ValidateRect", "Pascal", "void", ;
                           "int,string")  // used if aRect != NIL
                           // really we want a C far pointer to an
                           // array of 4 integers, but a Clipper string
                           // will do if it contains the right data
LOCAL c2 := GetProcAddress(hLib, "ValidateRect", "Pascal", "void", ;
                           "int,long")    // used if aRect == NIL
IF aRect != nil
   CallDLL(c1, hWnd, a2bin(aRect, "int[4]"))
ELSE
   CallDLL(c2, hWnd, 0)   // a C NULL far pointer
ENDIF
RETURN
