***************************************************************************
*Askforit International
*Amaury du Mesnil CIS: 100117,3327
***************************************************************************
*Here comes BMP functions
***************************************************************************
#Define  DIB_RGB_COLORS  0
#Define  DIB_PAL_COLORS  1
#Define  WIN_WANT_RASTEROPS
#Define  WIN_WANT_ALL
#Include "Windows.Ch"

#define W_RIGHT  3
#define W_BOTTOM 4

*=================================================================
Function ShowBmpRes(hWnd,nId,lStretch)
LOCAL hBitMap, hBmpOld, cBitMap
LOCAL hDC,hdcMemory
LOCAL aClientRect,xClient,yClient
LOCAL nX,nY
Local nWidth, nHeight
    lStretch    := if(ValType(lStretch)="L",lStretch,.F.)
    hBitMap     := LoadBitmap(_GetInstance(),nId)
    if !(hBitMap == 0)
        cBitMap := GetObject(hBitMap) 
        nWidth  := Bin2i(SubStr(cBitMap, 3, 2))  
        nHeight := Bin2i(SubStr(cBitMap, 5, 2))                  
        hDC     := GetDC(hWnd)
        hdcMemory:=CreateCompatibleDC(hDC)
        hbmpOld := SelectObject(hdcMemory, hBitMap)
        aClientRect:= GetClientRect(hWnd)
        xClient := aClientRect[W_RIGHT]
        yClient := aClientRect[W_BOTTOM]
        nX      := Max(0,((xClient -nWidth)/2))
        nY      := Max(0,((yClient -nHeight)/2))

        if lStretch
            StretchBlt(hDC,;
                        nX,nY,xClient,yClient,;
                        hdcMemory,;
                        0,0,nWidth,nHeight,;
                        SRCCOPY)                 
        else    
            AskBitBlt(hDC,;
                     nX,nY,nWidth,nHeight,;
                     hdcMemory,;
                     0,0,;
                     SRCCOPY)
        endif

        SelectObject(hdcMemory, hbmpOld)
        DeleteDC(hdcMemory)
        ReleaseDC(hWnd, hDC)
        DeleteObject(hBitMap)
    endif   
    return NIL

*============================================================================
Function ShowBmpFile(hWnd,cFileName,lStretch)
LOCAL hDC,cDIB
LOCAL aDIBRect,R_xBitMap,R_yBitMap
LOCAL aClientRect,xClient,yClient
LOCAL nX,nY
    lStretch    := if(ValType(lStretch)="L",lStretch,.F.)
    hDC         := GetDC(hWnd)
    cDIB        := ReadDIB(cFileName)

    aDIBRect    := GetDIBRect(cDIB)
    R_xBitMap   := aDIBRect[W_RIGHT]
    R_yBitMap   := aDIBRect[W_BOTTOM]

    aClientRect := GetClientRect(hWnd)
    xClient     := aClientRect[W_RIGHT]
    yClient     := aClientRect[W_BOTTOM]

    nX          := Max(0,((xClient -R_xBitMap)/2))
    nY          := Max(0,((yClient -R_yBitMap)/2))

    if lStretch
        StretchDIBits(hDC,nX,nY,xClient,yClient,0,0,R_xBitMap,R_yBitMap,;
                 NIL,cDIB,DIB_RGB_COLORS,SRCCOPY)
    else
       ShowDIB(hDC,cDIB,nX,nY)
    endif

    ReleaseDC(hWnd,hDC)
    return NIL
