***************************************************************************
*Askforit International
*Amaury du Mesnil CIS: 100117,3327
***************************************************************************
*Here comes useful DLL calls
***************************************************************************

#define WIN_WANT_ALL
#include "Windows.ch"
#include "AskDll.ch"

* =====================================
Procedure DlgDirList(hWndDlg,cPath,nId,nIdStaticPath,uFileType)
    Local hOldCursor:=SetCursor(LoadCursor(, IDC_WAIT))
    Local hLib :=LoadLibrary( "USER.EXE" )            // part of Windows
    Local nAdrs:=GetProcAddress(hLib,;                //dll
                                "DlgDirList",;        //fnct
                                "Pascal",;            //Langage
                                "int",;               //Result
                                "int,string, int,int,int" )//paraminfo

    cPath           := If(cPath=Nil,"",cPath)
    nIdStaticPath   := If(nIdStaticPath=Nil,0,nIdStaticPath)
    uFileType       := If(uFileType=Nil,"",uFileType)
    CallDll(nAdrs,hWndDlg,cPath,nId,nIdStaticPath,uFileType)
    FreeLibrary(hLib)
    SetCursor(hOldCursor)
    Return

* =====================================
Procedure DlgDirCombo(hWndDlg,cPath,nId,nIdStaticPath,uFileType)
    Local hOldCursor:=SetCursor(LoadCursor(, IDC_WAIT))
    Local hLib      :=LoadLibrary( "USER.EXE" )       // part of Windows
    Local nAdrs     :=GetProcAddress(hLib,;           //dll
                                    "DlgDirListComboBox",;//fnct
                                    "Pascal",;        //Langage
                                    "int",;           //Result
                                    "int,string, int,int,int" )//paraminfo

    cPath           := If(cPath=Nil,"",cPath)
    nIdStaticPath   := If(nIdStaticPath=Nil,0,nIdStaticPath)
    uFileType       := If(uFileType=Nil,"",uFileType)

    CallDll(nAdrs,hWndDlg,cPath,nId,nIdStaticPath,uFileType)

    FreeLibrary(hLib)
    SetCursor(hOldCursor)
    Return
    
*============================================================================
Function CreateCompatibleDC(hDC)
    LOCAL hLib    := LoadLibrary("GDI.EXE")
    LOCAL nAdrs   := GetProcAddress(hLib,;
                                    "CreateCompatibleDC",;
                                    "Pascal",;
                                    "int",;
                                    "int")
    LOCAL hCompDC := CallDLL(nAdrs, hDC)

    FreeLibrary(hLib)
    return hCompDC 
*============================================================================
Function AskBitBlt(hDCDest,nXDest,nYDest,;
                nBmpWidth,nBmpHeight,;
                hDCSource,nXSource,nYSource,;
                nROP)
    LOCAL hLib    := LoadLibrary("GDI.EXE")
    LOCAL cBB     := GetProcAddress(hLib,;
                                    "BitBlt",;
                                    "Pascal",;
                                    "bool",;
                                    "int,int,int,int,int,int,int,int,long")
    LOCAL Bitmap  := CallDLL(       cBB,;
                                    hDCDest,nXDest,nYDest,;
                                    nBmpWidth,nBmpHeight,;
                                    hDCSource,nXSource,nYSource,;
                                    nROP)

    FreeLibrary(hLib)                
    return BitMap
        
*============================================================================
Function StretchBlt(hDCDest,  nXDest,  nYDest,nWidthDest,nHeightDest,;
                    hDCSource,nXSource,nYSource,nWidthSour,nHeightSour,;
                    nROP)
    LOCAL hLib    := LoadLibrary("GDI.EXE")
    LOCAL cSB     := GetProcAddress(hLib,;
                                    "StretchBlt",;
                                    "Pascal",;
                                    "bool",;
                                    "bool")
    LOCAL Bitmap  := CallDLL(cSB,;
                       hDCDest,  nXDest,  nYDest,nWidthDest,nHeightDest,;
                     hDCSource,nXSource,nYSource,nWidthSour,nHeightSour,;
                     nROP)

    FreeLibrary(hLib)                
    return BitMap
    
*============================================================================
Function GetWindowRect(hWnd)
    LOCAL hLib:= LoadLibrary("USER.EXE")
    LOCAL cGWR:= GetProcAddress(hLib,;
                                "GetWindowRect",;
                                "Pascal",;
                                "nil",;
                                "int,str")
    LOCAL lpRc:= a2Bin({0,0,0,0},"int[4]")

    CallDLL(cGWR, hWnd, @lpRc)
    FreeLibrary(hLib)
    lpRc := Bin2a(lpRc,"int[4]")
    return lpRc 

*============================================================================
Procedure InvertRect(hDC, aRect)
    Local hLib:= LoadLibrary("USER.EXE")
    Local cIR := GetProcAddress(hLib,"InvertRect","Pascal","void","int,string")
    CallDLL(cIR, hDC, a2bin(aRect, "int[4]"))
    FreeLibrary(hLib)
    Return
    
