////////////////////////////
//
//	Clip-4-Win OO drag & drop sample
//
//	Copyright (C) 1994 Skelton Software, Kendal Cottage, Hillam, Leeds, UK.
//	All Rights Reserved.
//
//	Compile and link:  c4wbuild dragrop
//
////////////////////////////

#include "windows.ch"
#include "topclass.ch"
#include "commands.ch"


procedure main()
local	oApp, oWnd

oApp := App{"Clip-4-Win Drag and Drop Sample"}

oApp:Start()

oApp:Quit()

return


CLASS App INHERIT WApp
	METHOD Create(cText)	INLINE ::oWnd := MainWindow{self, cText}
ENDCLASS


CLASS MainWindow INHERIT WSDIWindow
	PROTECT cMsg	AS STRING

	METHOD DropFiles(aFiles)

	METHOD Init(oApp, cText)					;
	       INLINE super:Init(oApp, cText),				;
	              ::StatusBar := WStatusBar{self},			;
	              ::DragDrop := .t.,				;
	              ::cMsg := "Drop a file (try a DBF!)",		;
	              self

	METHOD Paint()			INLINE DrawText(::hDC, ::cMsg)
ENDCLASS


METHOD DropFiles(aFiles) CLASS MainWindow
local	i, cFile, oBrowse

::cMsg := "Drop a file (try a DBF!)"

for i = 1 to len(aFiles)
	if right(cFile := aFiles[i], 3) == "DBF"
		use (cFile) new shared
		oBrowse := WDBrowse{self, , , , , , , , , , , , cFile}
		close all
	else
		::cMsg += chr(13) + "Not a DBF:  " + cFile
		InvalidateRect(::hWnd)
	endif
next i
return nil

