
#include "windows.ch"


function main_rsmith()
local	hWnd := WinSetup("test", "test")


// NOTE: See RPTSMITH.HLP, topic DDE Conversations for more info.
//           ************

RptSmith(hWnd)
RSRuntime(hWnd)

return 0



function RptSmith(hWnd)
local	hServer

// Both System & command topics are supported.  command gets us ReportBasic.
// NOTE: You appear to be able to use DDE with app name "RptSmith" or
//       "ReportSmith"; the HLP file says "ReportSmith"...
//hServer = DDEStart(hWnd, "RptSmith", "command")
hServer = DDEStart(hWnd, "ReportSmith", "command")

if empty(hServer) .and. !RunRptSmith()
	return nil
endif

//hServer = DDEStart(hWnd, "RptSmith", "command")
hServer = DDEStart(hWnd, "ReportSmith", "command")

if empty(hServer)
	return nil
endif

// NOTE: *** This assumes the report is C:\RPT\TEST.RPT ***
//
// open, print & close - note sometimes you need embedded quotes (") or commas (,)

DDEExecute(hServer, hWnd, 'LoadReport "C:\RPT\TEST.RPT"', .f.)
// If you wanted to set some parameters, change the above to something like:
// DDEExecute(hServer, hWnd, 'LoadReport "C:\RPT\TEST.RPT","@Value=<100>"', .f.)

DDEExecute(hServer, hWnd, 'PrintReport 0,0,"","",""', .f.)
DDEExecute(hServer, hWnd, 'CloseReport 0', .f.)
DDEExecute(hServer, hWnd, 'CloseRS 0', .f.)

DDEStop(hServer, hWnd)

return nil



function RSRuntime(hWnd)
local	hServer

// Both System & command topics are supported.  command gets us ReportBasic:
hServer = DDEStart(hWnd, "RS_RunTime", "command")

if empty(hServer) .and. !RunRSRuntime()
	return nil
endif

hServer = DDEStart(hWnd, "RS_RunTime", "command")

if empty(hServer)
	return nil
endif

// NOTE: *** This assumes the report is C:\RPT\TEST.RPT ***
//
// open, print & close - note sometimes you need embedded quotes (") or commas (,)

DDEExecute(hServer, hWnd, 'LoadReport "C:\RPT\TEST.RPT"', .f.)
// If you wanted to set some parameters, change the above to something like:
// DDEExecute(hServer, hWnd, 'LoadReport "C:\RPT\TEST.RPT","@Value=<100>"', .f.)

DDEExecute(hServer, hWnd, 'PrintReport 0,0,"","",""', .f.)
DDEExecute(hServer, hWnd, 'CloseReport 0', .f.)
DDEExecute(hServer, hWnd, 'CloseRS 0', .f.)
DDEExecute(hServer, hWnd, '', .f.)

DDEStop(hServer, hWnd)

return nil



function RunRptSmith()		// --> .t. if started ok
local	hModule, cDir, cFile, cWordDir, cDoc

// try a simple RUN
hModule = WinExec("RPTSMITH.EXE", SW_SHOWMINNOACTIVE)

if hModule >= 32
	return .t.
endif

// didn't run, start hunting for it...

// try [Extensions] in WIN.INI
cDoc = GetProfString("Extensions", "rpt", "")
cDoc = left(cDoc + " ", at(" ", cDoc) - 1)	// remove " ^.rpt" if there
if !empty(cDoc)
	hModule = WinExec(cDoc, SW_SHOWMINNOACTIVE)
	if hModule >= 32
		return .t.
	endif
endif

return .f.	// failed



function RunRSRuntime()		// --> .t. if started ok
local	hModule, cDir, cFile, cWordDir, cDoc

// try a simple RUN
hModule = WinExec("RS_RUN.EXE", SW_SHOWMINNOACTIVE)

if hModule >= 32
	return .t.
endif

// didn't run, start hunting for it...

// try [Extensions] in WIN.INI
cDoc = GetProfString("Extensions", "rpt", "")
cDoc = left(cDoc + " ", at(" ", cDoc) - 1)	// remove " ^.rpt" if there
if !empty(cDoc)
	hModule = WinExec(cDoc, SW_SHOWMINNOACTIVE)
	if hModule >= 32
		return .t.
	endif
endif

return .f.	// failed

