/*
 *	dos.c - support routines for Clip-4-Win
 *
 *	Written by:	John M. Skelton,  2-Dec-93.
 *
 *	Copyright (C) 1993 Skelton Software, Kendal Cottage, Hillam, Leeds LS25 5HP.
 *	All Rights Reserved.
 */


#include "extend.h"

// extend.h wants this as #define, and also a typedef: must be a mistake!
#undef	WORD
#define	CLIPWORD	128


#include "stdlib.h"


typedef	unsigned char	uchar;
typedef	unsigned int	uint;
typedef	unsigned long	ulong;


#define	NELEMS(arr)	(sizeof(arr) / sizeof(arr[0]))

#define	BELL	7
#define	BS	8
#define	LF	10
#define	CR	13



static char	*copyright[] =
{
	"Copyright (C) 1993 Skelton Software, Kendal Cottage, Hillam, Leeds, UK.",
	"All Rights Reserved."
};


CLIPPER C4W_DiskFr/*ee*/(void)		// (nDisk) --> nBytesFree
{
	uchar	nDisk = (uchar) _parni(1);  // 0=current drive, 1=A:, etc.
	uint	nBytesPerSector;
	uint	nSectorsPerCluster;
	uint	nClusters;
	uint	nClustersFree;

_asm	mov	dl,nDisk
_asm	mov	ah,36h
_asm	int	21h
_asm	mov	nBytesPerSector,cx
_asm	mov	nSectorsPerCluster,ax
_asm	mov	nClusters,dx
_asm	mov	nClustersFree,bx

	if (nSectorsPerCluster == 0xffff)
		_ret();			// nil means error (invalid drive)
	else
		_retnl((ulong) nBytesPerSector * nSectorsPerCluster * nClustersFree);
}


CLIPPER C4W_GetDri/*ve*/(void)		// () --> nDisk  (0=A:, ..., 25=Z:)
{
	int	nDisk;

_asm	mov	ah,19h
_asm	int	21h
_asm	cbw
_asm	mov	nDisk,ax

	_retni(nDisk);
}

