////////////////////////////
//
//	Clip-4-Win sample source
//
//	Copyright (C) 1992 Skelton Software, Kendal Cottage, Hillam, Leeds, UK.
//	All Rights Reserved.
//
//	Using DLL's is shown here.
//
////////////////////////////

#include "windows.ch"


// Windows ScrollWindow(), via DLL
//
// Syntax:
//	WScrollWindow( <hWnd>, <nDX>, <nDY>, <aScroll>, <aClip> )  -->  nil
// Arguments:
// <hWnd> is a window handle.
// <nDX>, <nDY> are the changes in x,y wanted.
// <aScroll> is a rectangle describing the area to scroll.
// <aClip> is the clipping rectangle.

procedure WScrollWindow(hWnd, nDX, nDY, aScroll, aClip)
local	hLib, cScrWin, cScroll, cClip
if (hLib := LoadLibrary("USER.EXE")) < 32				;
   .or. (cScrWin := GetProcAddress(hLib, "ScrollWindow", "Pascal",	;
				   "void", "HWND,int,int,str,str")) == nil
	return
endif
// convert the Clipper arrays to strings (equivalent to the C structures)
cScroll = a2bin(aScroll, "int[4]")
cClip = a2bin(aClip, "int[4]")
CallDLL(cScrWin, hWnd, nDX, nDY, cScroll, cClip)
FreeLibrary(hLib)
return


// GetTextMetrics(), via DLL
//
//	(see TEXTMETR.PRG)

