***************************************************************************
*Askforit International
*Amaury du Mesnil CIS: 100117,3327
***************************************************************************
*Here comes a recursive function to debug multidimentional arrays
*ArrDebug(array))
*
*NEEDS THE RESOURCE DEBUGARRAY IN ASK4IT.RES
***************************************************************************

#define WIN_WANT_ALL
#define WIN_WANT_LB
#include "Windows.ch"
Static Dimention

*======================================
Func ProcDebug()
    Local i := 0
    Local a := {}
    while ( !Empty(ProcName(i)) )
        Aadd(a, Trim(MethodName(i))+"("+Ltrim(str(ProcLine(i)))+")" )
        i++
    end
    ArrDebug(a)
    Return Nil

* ====================================
Func ArrDebug(array,hParent,cTitle)
    Dimention   := 1
    DialogBox(_GetInstance(), "DEBUGARRAY", hParent,;
         {|hWndDlg, msg, wparam, lparam| Debug(hWndDlg, msg, wparam, lparam,array,cTitle)})
    Return Nil

* ======================================
Static function Debug(hWndDlg, nMsg, nwParam, nlParam,array,cTitle)
    Local cstr
    Local nCurrSel
    Local nLen
    
    do case
    case nMsg == WM_INITDIALOG
        cTitle := if( cTitle=Nil, [], cTitle )
        SendMessage( hWndDlg, WM_SETTEXT, 0, cTitle)
        SendDlgItemMessage( hWndDlg, 101, WM_SETFONT, GetStockObject(OEM_FIXED_FONT), 0)//1 to redraw immediately otherwise 0
        Aeval(array,{|a,i|  cStr := Transform( i, "@B 9999" ),;
                            doString( a, @cstr ),;
                            SendDlgItemMessage(hWndDlg,101, LB_ADDSTRING, 0, cStr) })
        return 1                                      // want system to set the focus

    Case nMsg == WM_COMMAND
        do case
        case nwParam == 101                           //list
            nLParam     := Int(nLParam/65536)
            If nLParam == LBN_DBLCLK
                nCurrSel:= 1+SendDlgItemMessage(hWndDlg,101,LB_GETCURSEL,0,0)
                nLen    := SendMessage(hWndDlg, WM_GETTEXTLENGTH, 0, 0) + 1
                cStr    := space(nLen)
                nLen    := SendMessage(hWndDlg, WM_GETTEXT, nLen, @cStr)// note: not an EM_ msg
                cTitle  := left(cStr, nLen)
                
                If Valtype(array[nCurrsel])=="A".or.Valtype(array[nCurrsel])=="O"
                    ArrDebug(array[nCurrSel],Nil,cTitle+"["+Ltrim(Str(nCurrSel))+"]")//Recursif
                Endif
                
            Endif
            
        case nwParam == 102                           //Ok
            EndDialog(hWndDlg, nwParam)
            return 1                                  // means msg has been processed
        endcase
    endcase
    return 0                                          // means msg not processed 


* =====================================
Static func DoString(a,cStr)
    cStr+=xtoc(a)
    Return cStr
     
* =====================================
Static func xtoC(x)
    Local cValtype:=Valtype(x)
    Local c:=""
    
    c+=cValtype
    c+=":"
    do Case
    Case cValtype=="C"
        c+=AnsiToOem("")
        c+=x
        c+=AnsiToOem("")
    Case cValtype=="N"
        c+=Str(x)
    Case cValtype=="L"
        c+=If(x,".T.",".F.")
    Case cValtype=="D"
        c+=DtoC(x)
    Case cValtype=="B"
        c+="<block>"
    Case cValtype=="A"
        c+="< arr["+Ltrim(str(Len(x)))+"] >"
    EndCase
    Return c
